commit f47f9d0d5baa25c6f836e50307271631bd0b654d
Author: Jonas Haag <jonas@lophus.org>
Date:   Fri Mar 23 18:50:57 2012 +0100

    with-statements.patch

diff --git a/django/contrib/auth/tests/forms.py b/django/contrib/auth/tests/forms.py
index 2397b52..97e9c33 100644
--- a/django/contrib/auth/tests/forms.py
+++ b/django/contrib/auth/tests/forms.py
@@ -1,4 +1,3 @@
-from __future__ import with_statement
 import os
 from django.contrib.auth.models import User
 from django.contrib.auth.forms import (UserCreationForm, AuthenticationForm,
diff --git a/django/contrib/auth/tests/views.py b/django/contrib/auth/tests/views.py
index 7244086..37045cd 100644
--- a/django/contrib/auth/tests/views.py
+++ b/django/contrib/auth/tests/views.py
@@ -1,4 +1,3 @@
-from __future__ import with_statement
 import os
 import re
 import urllib
diff --git a/django/contrib/contenttypes/tests.py b/django/contrib/contenttypes/tests.py
index 3b7906c..12033c4 100644
--- a/django/contrib/contenttypes/tests.py
+++ b/django/contrib/contenttypes/tests.py
@@ -1,4 +1,3 @@
-from __future__ import with_statement
 
 import urllib
 
diff --git a/django/contrib/flatpages/tests/forms.py b/django/contrib/flatpages/tests/forms.py
index 12b47e8..ff02d68 100644
--- a/django/contrib/flatpages/tests/forms.py
+++ b/django/contrib/flatpages/tests/forms.py
@@ -1,4 +1,3 @@
-from __future__ import with_statement
 
 from django.conf import settings
 from django.contrib.flatpages.forms import FlatpageForm
diff --git a/django/contrib/formtools/tests/wizard/wizardtests/tests.py b/django/contrib/formtools/tests/wizard/wizardtests/tests.py
index 2ef39dc..24234e4 100644
--- a/django/contrib/formtools/tests/wizard/wizardtests/tests.py
+++ b/django/contrib/formtools/tests/wizard/wizardtests/tests.py
@@ -1,4 +1,3 @@
-from __future__ import with_statement
 import os
 
 from django import forms
diff --git a/django/contrib/humanize/tests.py b/django/contrib/humanize/tests.py
index f921b12..2decc4e 100644
--- a/django/contrib/humanize/tests.py
+++ b/django/contrib/humanize/tests.py
@@ -1,4 +1,3 @@
-from __future__ import with_statement
 
 import datetime
 import new
diff --git a/django/contrib/sessions/tests.py b/django/contrib/sessions/tests.py
index 7686bd2..4d2fefe 100644
--- a/django/contrib/sessions/tests.py
+++ b/django/contrib/sessions/tests.py
@@ -1,4 +1,3 @@
-from __future__ import with_statement
 
 from datetime import datetime, timedelta
 import shutil
diff --git a/django/contrib/staticfiles/management/commands/collectstatic.py b/django/contrib/staticfiles/management/commands/collectstatic.py
index 850b013..859538b 100644
--- a/django/contrib/staticfiles/management/commands/collectstatic.py
+++ b/django/contrib/staticfiles/management/commands/collectstatic.py
@@ -1,4 +1,3 @@
-from __future__ import with_statement
 
 import os
 import sys
diff --git a/django/contrib/staticfiles/storage.py b/django/contrib/staticfiles/storage.py
index c000f97..ea18497 100644
--- a/django/contrib/staticfiles/storage.py
+++ b/django/contrib/staticfiles/storage.py
@@ -1,4 +1,3 @@
-from __future__ import with_statement
 import hashlib
 import os
 import posixpath
diff --git a/django/core/cache/backends/locmem.py b/django/core/cache/backends/locmem.py
index 6ba0c98..701891e 100644
--- a/django/core/cache/backends/locmem.py
+++ b/django/core/cache/backends/locmem.py
@@ -1,6 +1,5 @@
 "Thread-safe in-memory cache backend."
 
-from __future__ import with_statement
 
 import time
 try:
diff --git a/django/core/management/base.py b/django/core/management/base.py
index db855e1..aec1a99 100644
--- a/django/core/management/base.py
+++ b/django/core/management/base.py
@@ -3,7 +3,6 @@ Base classes for writing management commands (named commands which can
 be executed through ``django-admin.py`` or ``manage.py``).
 
 """
-from __future__ import with_statement
 import os
 import sys
 
diff --git a/django/core/management/commands/loaddata.py b/django/core/management/commands/loaddata.py
index 0c234fb..176ccef 100644
--- a/django/core/management/commands/loaddata.py
+++ b/django/core/management/commands/loaddata.py
@@ -1,6 +1,5 @@
 # This is necessary in Python 2.5 to enable the with statement, in 2.6
 # and up it is no longer necessary.
-from __future__ import with_statement
 
 import sys
 import os
diff --git a/django/core/management/templates.py b/django/core/management/templates.py
index 9a4b2c1..b2a1226 100644
--- a/django/core/management/templates.py
+++ b/django/core/management/templates.py
@@ -1,4 +1,3 @@
-from __future__ import with_statement
 import cgi
 import errno
 import mimetypes
diff --git a/django/db/transaction.py b/django/db/transaction.py
index 4ecd2d1..f3ce2b2 100644
--- a/django/db/transaction.py
+++ b/django/db/transaction.py
@@ -11,7 +11,6 @@ called, a commit is made.
 Managed transactions don't do those commits, but will need some kind of manual
 or implicit commits or rollbacks.
 """
-from __future__ import with_statement
 
 from functools import wraps
 
diff --git a/django/templatetags/i18n.py b/django/templatetags/i18n.py
index dc3d93e..ca79f41 100644
--- a/django/templatetags/i18n.py
+++ b/django/templatetags/i18n.py
@@ -1,4 +1,3 @@
-from __future__ import with_statement
 import re
 
 from django.template import (Node, Variable, TemplateSyntaxError,
diff --git a/django/templatetags/tz.py b/django/templatetags/tz.py
index 48c511f..c303b41 100644
--- a/django/templatetags/tz.py
+++ b/django/templatetags/tz.py
@@ -1,4 +1,3 @@
-from __future__ import with_statement
 
 from datetime import datetime, tzinfo
 
diff --git a/django/test/testcases.py b/django/test/testcases.py
index b5e1dc0..5413177 100644
--- a/django/test/testcases.py
+++ b/django/test/testcases.py
@@ -1,4 +1,3 @@
-from __future__ import with_statement
 
 import difflib
 import os
diff --git a/django/test/utils.py b/django/test/utils.py
index ed5ab59..3f38428 100644
--- a/django/test/utils.py
+++ b/django/test/utils.py
@@ -1,4 +1,3 @@
-from __future__ import with_statement
 
 import warnings
 from django.conf import settings, UserSettingsHolder
diff --git a/django/utils/archive.py b/django/utils/archive.py
index 9c2d4ac..027acf7 100644
--- a/django/utils/archive.py
+++ b/django/utils/archive.py
@@ -21,7 +21,6 @@ LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
 """
-from __future__ import with_statement
 import os
 import shutil
 import sys
diff --git a/django/utils/synch.py b/django/utils/synch.py
index d6ae2f0..7c19a36 100644
--- a/django/utils/synch.py
+++ b/django/utils/synch.py
@@ -6,7 +6,6 @@ Synchronization primitives:
 (Contributed to Django by eugene@lazutkin.com)
 """
 
-from __future__ import with_statement
 
 import contextlib
 try:
diff --git a/django/views/static.py b/django/views/static.py
index ed23779..2a75613 100644
--- a/django/views/static.py
+++ b/django/views/static.py
@@ -2,7 +2,6 @@
 Views and functions for serving static files. These are only to be used
 during development, and SHOULD NOT be used in a production setting.
 """
-from __future__ import with_statement
 
 import mimetypes
 import os
diff --git a/tests/modeltests/distinct_on_fields/tests.py b/tests/modeltests/distinct_on_fields/tests.py
index 5021bc8..4d827d1 100644
--- a/tests/modeltests/distinct_on_fields/tests.py
+++ b/tests/modeltests/distinct_on_fields/tests.py
@@ -1,4 +1,4 @@
-from __future__ import absolute_import, with_statement
+from __future__ import absolute_import
 
 from django.db.models import Max
 from django.test import TestCase, skipUnlessDBFeature
diff --git a/tests/modeltests/empty/tests.py b/tests/modeltests/empty/tests.py
index 255b80e..db464c6 100644
--- a/tests/modeltests/empty/tests.py
+++ b/tests/modeltests/empty/tests.py
@@ -1,4 +1,4 @@
-from __future__ import with_statement, absolute_import
+from __future__ import absolute_import
 
 from django.conf import settings
 from django.core.exceptions import ImproperlyConfigured
diff --git a/tests/modeltests/files/tests.py b/tests/modeltests/files/tests.py
index 50017be..3bfe193 100644
--- a/tests/modeltests/files/tests.py
+++ b/tests/modeltests/files/tests.py
@@ -1,4 +1,4 @@
-from __future__ import with_statement, absolute_import
+from __future__ import absolute_import
 
 import shutil
 import tempfile
diff --git a/tests/modeltests/lookup/tests.py b/tests/modeltests/lookup/tests.py
index 3571e21..60ab25f 100644
--- a/tests/modeltests/lookup/tests.py
+++ b/tests/modeltests/lookup/tests.py
@@ -1,4 +1,4 @@
-from __future__ import absolute_import, with_statement
+from __future__ import absolute_import
 
 from datetime import datetime
 from operator import attrgetter
diff --git a/tests/modeltests/many_to_many/tests.py b/tests/modeltests/many_to_many/tests.py
index 9fa524f..44bdde3 100644
--- a/tests/modeltests/many_to_many/tests.py
+++ b/tests/modeltests/many_to_many/tests.py
@@ -1,4 +1,4 @@
-from __future__ import absolute_import, with_statement
+from __future__ import absolute_import
 
 from django.test import TestCase
 
diff --git a/tests/modeltests/many_to_one/tests.py b/tests/modeltests/many_to_one/tests.py
index d9d67bb..aed952f 100644
--- a/tests/modeltests/many_to_one/tests.py
+++ b/tests/modeltests/many_to_one/tests.py
@@ -1,4 +1,4 @@
-from __future__ import absolute_import, with_statement
+from __future__ import absolute_import
 
 from copy import deepcopy
 from datetime import datetime
diff --git a/tests/modeltests/many_to_one_null/tests.py b/tests/modeltests/many_to_one_null/tests.py
index 1e302ec..1a404bd 100644
--- a/tests/modeltests/many_to_one_null/tests.py
+++ b/tests/modeltests/many_to_one_null/tests.py
@@ -1,4 +1,4 @@
-from __future__ import with_statement, absolute_import
+from __future__ import absolute_import
 
 from django.test import TestCase
 
diff --git a/tests/modeltests/model_forms/tests.py b/tests/modeltests/model_forms/tests.py
index a2ad024..559ef0a 100644
--- a/tests/modeltests/model_forms/tests.py
+++ b/tests/modeltests/model_forms/tests.py
@@ -1,4 +1,4 @@
-from __future__ import with_statement, absolute_import
+from __future__ import absolute_import
 
 import datetime
 import os
diff --git a/tests/modeltests/prefetch_related/tests.py b/tests/modeltests/prefetch_related/tests.py
index b0bc435..135b5b8 100644
--- a/tests/modeltests/prefetch_related/tests.py
+++ b/tests/modeltests/prefetch_related/tests.py
@@ -1,4 +1,4 @@
-from __future__ import with_statement, absolute_import
+from __future__ import absolute_import
 
 from django.contrib.contenttypes.models import ContentType
 from django.test import TestCase
diff --git a/tests/modeltests/properties/tests.py b/tests/modeltests/properties/tests.py
index f01b22a..8a40d06 100644
--- a/tests/modeltests/properties/tests.py
+++ b/tests/modeltests/properties/tests.py
@@ -1,4 +1,4 @@
-from __future__ import with_statement, absolute_import
+from __future__ import absolute_import
 
 from django.test import TestCase
 
diff --git a/tests/modeltests/select_related/tests.py b/tests/modeltests/select_related/tests.py
index 1b3715a..ebe2f8c 100644
--- a/tests/modeltests/select_related/tests.py
+++ b/tests/modeltests/select_related/tests.py
@@ -1,4 +1,4 @@
-from __future__ import with_statement, absolute_import
+from __future__ import absolute_import
 
 from django.test import TestCase
 
diff --git a/tests/modeltests/serializers/tests.py b/tests/modeltests/serializers/tests.py
index 309a83e..d474937 100644
--- a/tests/modeltests/serializers/tests.py
+++ b/tests/modeltests/serializers/tests.py
@@ -1,6 +1,6 @@
 # This is necessary in Python 2.5 to enable the with statement, in 2.6
 # and up it is no longer necessary.
-from __future__ import with_statement, absolute_import
+from __future__ import absolute_import
 
 # -*- coding: utf-8 -*-
 from datetime import datetime
diff --git a/tests/modeltests/timezones/tests.py b/tests/modeltests/timezones/tests.py
index 171c218..5ed5ae7 100644
--- a/tests/modeltests/timezones/tests.py
+++ b/tests/modeltests/timezones/tests.py
@@ -1,4 +1,3 @@
-from __future__ import with_statement
 
 import datetime
 import os
diff --git a/tests/modeltests/transactions/tests.py b/tests/modeltests/transactions/tests.py
index ed416e2..f3246ee 100644
--- a/tests/modeltests/transactions/tests.py
+++ b/tests/modeltests/transactions/tests.py
@@ -1,4 +1,4 @@
-from __future__ import with_statement, absolute_import
+from __future__ import absolute_import
 
 from django.db import connection, transaction, IntegrityError
 from django.test import TransactionTestCase, skipUnlessDBFeature
diff --git a/tests/modeltests/user_commands/tests.py b/tests/modeltests/user_commands/tests.py
index e138e07..360ee50 100644
--- a/tests/modeltests/user_commands/tests.py
+++ b/tests/modeltests/user_commands/tests.py
@@ -1,4 +1,3 @@
-from __future__ import with_statement
 
 from StringIO import StringIO
 
diff --git a/tests/modeltests/validation/__init__.py b/tests/modeltests/validation/__init__.py
index 4a1ad3a..728b04a 100644
--- a/tests/modeltests/validation/__init__.py
+++ b/tests/modeltests/validation/__init__.py
@@ -1,4 +1,3 @@
-from __future__ import with_statement
 
 from django.core.exceptions import ValidationError
 from django.test import TestCase
diff --git a/tests/modeltests/validation/test_unique.py b/tests/modeltests/validation/test_unique.py
index 3ae981d..497bb9d 100644
--- a/tests/modeltests/validation/test_unique.py
+++ b/tests/modeltests/validation/test_unique.py
@@ -1,4 +1,4 @@
-from __future__ import with_statement, absolute_import
+from __future__ import absolute_import
 
 import datetime
 
diff --git a/tests/regressiontests/admin_changelist/tests.py b/tests/regressiontests/admin_changelist/tests.py
index d2b017b..7e4546e 100644
--- a/tests/regressiontests/admin_changelist/tests.py
+++ b/tests/regressiontests/admin_changelist/tests.py
@@ -1,4 +1,4 @@
-from __future__ import with_statement, absolute_import
+from __future__ import absolute_import
 
 from django.contrib import admin
 from django.contrib.admin.options import IncorrectLookupParameters
diff --git a/tests/regressiontests/admin_scripts/tests.py b/tests/regressiontests/admin_scripts/tests.py
index 669c6e8..dd3b0b4 100644
--- a/tests/regressiontests/admin_scripts/tests.py
+++ b/tests/regressiontests/admin_scripts/tests.py
@@ -3,7 +3,6 @@ A series of tests to establish that the command-line managment tools work as
 advertised - especially with regards to the handling of the DJANGO_SETTINGS_MODULE
 and default settings.py files.
 """
-from __future__ import with_statement
 
 import os
 import re
diff --git a/tests/regressiontests/admin_views/tests.py b/tests/regressiontests/admin_views/tests.py
index 12f1c67..b471844 100644
--- a/tests/regressiontests/admin_views/tests.py
+++ b/tests/regressiontests/admin_views/tests.py
@@ -1,5 +1,5 @@
 # coding: utf-8
-from __future__ import with_statement, absolute_import
+from __future__ import absolute_import
 
 import os
 import re
diff --git a/tests/regressiontests/admin_widgets/tests.py b/tests/regressiontests/admin_widgets/tests.py
index 87e0309..ab6db4d 100644
--- a/tests/regressiontests/admin_widgets/tests.py
+++ b/tests/regressiontests/admin_widgets/tests.py
@@ -1,5 +1,5 @@
 # encoding: utf-8
-from __future__ import with_statement, absolute_import
+from __future__ import absolute_import
 
 from datetime import datetime
 
diff --git a/tests/regressiontests/backends/tests.py b/tests/regressiontests/backends/tests.py
index cfb662e..d5b1ea8 100644
--- a/tests/regressiontests/backends/tests.py
+++ b/tests/regressiontests/backends/tests.py
@@ -1,6 +1,6 @@
 # -*- coding: utf-8 -*-
 # Unit and doctests for specific database backends.
-from __future__ import with_statement, absolute_import
+from __future__ import absolute_import
 
 import datetime
 import threading
diff --git a/tests/regressiontests/bug8245/tests.py b/tests/regressiontests/bug8245/tests.py
index b756b84..820318f 100644
--- a/tests/regressiontests/bug8245/tests.py
+++ b/tests/regressiontests/bug8245/tests.py
@@ -1,4 +1,3 @@
-from __future__ import with_statement
 
 from django.contrib import admin
 from django.utils.unittest import TestCase
diff --git a/tests/regressiontests/bulk_create/tests.py b/tests/regressiontests/bulk_create/tests.py
index 0fa142b..284ea9f 100644
--- a/tests/regressiontests/bulk_create/tests.py
+++ b/tests/regressiontests/bulk_create/tests.py
@@ -1,4 +1,4 @@
-from __future__ import with_statement, absolute_import
+from __future__ import absolute_import
 
 from operator import attrgetter
 
diff --git a/tests/regressiontests/cache/tests.py b/tests/regressiontests/cache/tests.py
index bd29cde..6dbc03d 100644
--- a/tests/regressiontests/cache/tests.py
+++ b/tests/regressiontests/cache/tests.py
@@ -2,7 +2,7 @@
 
 # Unit tests for cache framework
 # Uses whatever cache backend is set in the test settings file.
-from __future__ import with_statement, absolute_import
+from __future__ import absolute_import
 
 import hashlib
 import os
diff --git a/tests/regressiontests/comment_tests/tests/model_tests.py b/tests/regressiontests/comment_tests/tests/model_tests.py
index 11d96ae..69c1a81 100644
--- a/tests/regressiontests/comment_tests/tests/model_tests.py
+++ b/tests/regressiontests/comment_tests/tests/model_tests.py
@@ -1,4 +1,4 @@
-from __future__ import absolute_import, with_statement
+from __future__ import absolute_import
 
 from django.contrib.comments.models import Comment
 
diff --git a/tests/regressiontests/comment_tests/tests/templatetag_tests.py b/tests/regressiontests/comment_tests/tests/templatetag_tests.py
index 0b036ce..62b3fb3 100644
--- a/tests/regressiontests/comment_tests/tests/templatetag_tests.py
+++ b/tests/regressiontests/comment_tests/tests/templatetag_tests.py
@@ -1,4 +1,4 @@
-from __future__ import with_statement, absolute_import
+from __future__ import absolute_import
 
 from django.contrib.comments.forms import CommentForm
 from django.contrib.comments.models import Comment
diff --git a/tests/regressiontests/csrf_tests/tests.py b/tests/regressiontests/csrf_tests/tests.py
index 71400ea..d403951 100644
--- a/tests/regressiontests/csrf_tests/tests.py
+++ b/tests/regressiontests/csrf_tests/tests.py
@@ -1,5 +1,4 @@
 # -*- coding: utf-8 -*-
-from __future__ import with_statement
 
 from django.conf import settings
 from django.core.context_processors import csrf
diff --git a/tests/regressiontests/defaultfilters/tests.py b/tests/regressiontests/defaultfilters/tests.py
index 1660a75..38e44d4 100644
--- a/tests/regressiontests/defaultfilters/tests.py
+++ b/tests/regressiontests/defaultfilters/tests.py
@@ -1,5 +1,4 @@
 # -*- coding: utf-8 -*-
-from __future__ import with_statement
 
 import datetime
 import decimal
diff --git a/tests/regressiontests/defer_regress/tests.py b/tests/regressiontests/defer_regress/tests.py
index 4afe39b..c9baad6 100644
--- a/tests/regressiontests/defer_regress/tests.py
+++ b/tests/regressiontests/defer_regress/tests.py
@@ -1,4 +1,4 @@
-from __future__ import with_statement, absolute_import
+from __future__ import absolute_import
 
 from operator import attrgetter
 
diff --git a/tests/regressiontests/forms/tests/models.py b/tests/regressiontests/forms/tests/models.py
index b5e2c3a..64cd18b 100644
--- a/tests/regressiontests/forms/tests/models.py
+++ b/tests/regressiontests/forms/tests/models.py
@@ -1,5 +1,5 @@
 # -*- coding: utf-8 -*-
-from __future__ import with_statement, absolute_import
+from __future__ import absolute_import
 
 import datetime
 
diff --git a/tests/regressiontests/forms/tests/regressions.py b/tests/regressiontests/forms/tests/regressions.py
index a93781d..267ef30 100644
--- a/tests/regressiontests/forms/tests/regressions.py
+++ b/tests/regressiontests/forms/tests/regressions.py
@@ -1,5 +1,4 @@
 # -*- coding: utf-8 -*-
-from __future__ import with_statement
 from django.forms import *
 from django.test import TestCase
 from django.utils.translation import ugettext_lazy, override
diff --git a/tests/regressiontests/i18n/commands/compilation.py b/tests/regressiontests/i18n/commands/compilation.py
index ee558b2..113b412 100644
--- a/tests/regressiontests/i18n/commands/compilation.py
+++ b/tests/regressiontests/i18n/commands/compilation.py
@@ -1,4 +1,3 @@
-from __future__ import with_statement
 
 import os
 try:
diff --git a/tests/regressiontests/i18n/commands/extraction.py b/tests/regressiontests/i18n/commands/extraction.py
index 4eb7abc..fb9ca4e 100644
--- a/tests/regressiontests/i18n/commands/extraction.py
+++ b/tests/regressiontests/i18n/commands/extraction.py
@@ -1,5 +1,4 @@
 # -*- encoding: utf-8 -*-
-from __future__ import with_statement
 
 import os
 import re
diff --git a/tests/regressiontests/i18n/contenttypes/tests.py b/tests/regressiontests/i18n/contenttypes/tests.py
index 79928d9..a44895f 100644
--- a/tests/regressiontests/i18n/contenttypes/tests.py
+++ b/tests/regressiontests/i18n/contenttypes/tests.py
@@ -1,5 +1,4 @@
 # coding: utf-8
-from __future__ import with_statement
 
 import os
 
diff --git a/tests/regressiontests/i18n/patterns/tests.py b/tests/regressiontests/i18n/patterns/tests.py
index 16fbec0..1af2bea 100644
--- a/tests/regressiontests/i18n/patterns/tests.py
+++ b/tests/regressiontests/i18n/patterns/tests.py
@@ -1,4 +1,3 @@
-from __future__ import with_statement
 
 import os
 import warnings
diff --git a/tests/regressiontests/i18n/tests.py b/tests/regressiontests/i18n/tests.py
index 99a55bd..f0b4a61 100644
--- a/tests/regressiontests/i18n/tests.py
+++ b/tests/regressiontests/i18n/tests.py
@@ -1,5 +1,5 @@
 # -*- encoding: utf-8 -*-
-from __future__ import with_statement, absolute_import
+from __future__ import absolute_import
 
 import datetime
 import decimal
diff --git a/tests/regressiontests/logging_tests/tests.py b/tests/regressiontests/logging_tests/tests.py
index 4e29e25..1cf9e85 100644
--- a/tests/regressiontests/logging_tests/tests.py
+++ b/tests/regressiontests/logging_tests/tests.py
@@ -1,4 +1,3 @@
-from __future__ import with_statement
 
 import copy
 
diff --git a/tests/regressiontests/model_formsets_regress/tests.py b/tests/regressiontests/model_formsets_regress/tests.py
index d058f1d..f1e935e 100644
--- a/tests/regressiontests/model_formsets_regress/tests.py
+++ b/tests/regressiontests/model_formsets_regress/tests.py
@@ -1,4 +1,4 @@
-from __future__ import absolute_import, with_statement
+from __future__ import absolute_import
 
 from django import forms
 from django.forms.formsets import BaseFormSet, DELETION_FIELD_NAME
diff --git a/tests/regressiontests/modeladmin/tests.py b/tests/regressiontests/modeladmin/tests.py
index f9dec69..04b02eb 100644
--- a/tests/regressiontests/modeladmin/tests.py
+++ b/tests/regressiontests/modeladmin/tests.py
@@ -1,4 +1,4 @@
-from __future__ import absolute_import, with_statement
+from __future__ import absolute_import
 
 from datetime import date
 
diff --git a/tests/regressiontests/requests/tests.py b/tests/regressiontests/requests/tests.py
index b7a4788..11d2e45 100644
--- a/tests/regressiontests/requests/tests.py
+++ b/tests/regressiontests/requests/tests.py
@@ -1,4 +1,3 @@
-from __future__ import with_statement
 
 import time
 import warnings
diff --git a/tests/regressiontests/select_related_onetoone/tests.py b/tests/regressiontests/select_related_onetoone/tests.py
index 643a0ff..d57ee90 100644
--- a/tests/regressiontests/select_related_onetoone/tests.py
+++ b/tests/regressiontests/select_related_onetoone/tests.py
@@ -1,4 +1,4 @@
-from __future__ import with_statement, absolute_import
+from __future__ import absolute_import
 
 from django.test import TestCase
 
diff --git a/tests/regressiontests/serializers_regress/tests.py b/tests/regressiontests/serializers_regress/tests.py
index 65194da..cbc7bd9 100644
--- a/tests/regressiontests/serializers_regress/tests.py
+++ b/tests/regressiontests/serializers_regress/tests.py
@@ -8,7 +8,7 @@ forward, backwards and self references.
 """
 # This is necessary in Python 2.5 to enable the with statement, in 2.6
 # and up it is no longer necessary.
-from __future__ import with_statement, absolute_import
+from __future__ import absolute_import
 
 import datetime
 import decimal
diff --git a/tests/regressiontests/settings_tests/tests.py b/tests/regressiontests/settings_tests/tests.py
index a2e6c49..9d87315 100644
--- a/tests/regressiontests/settings_tests/tests.py
+++ b/tests/regressiontests/settings_tests/tests.py
@@ -1,4 +1,3 @@
-from __future__ import with_statement
 
 import os
 
diff --git a/tests/regressiontests/staticfiles_tests/tests.py b/tests/regressiontests/staticfiles_tests/tests.py
index 733c3cc..7639161 100644
--- a/tests/regressiontests/staticfiles_tests/tests.py
+++ b/tests/regressiontests/staticfiles_tests/tests.py
@@ -1,5 +1,4 @@
 # -*- encoding: utf-8 -*-
-from __future__ import with_statement
 
 import codecs
 import os
diff --git a/tests/regressiontests/templates/response.py b/tests/regressiontests/templates/response.py
index 5feb8cc..811359e 100644
--- a/tests/regressiontests/templates/response.py
+++ b/tests/regressiontests/templates/response.py
@@ -1,4 +1,3 @@
-from __future__ import with_statement
 
 import os
 import pickle
diff --git a/tests/regressiontests/templates/tests.py b/tests/regressiontests/templates/tests.py
index f74aa75..e166f7e 100644
--- a/tests/regressiontests/templates/tests.py
+++ b/tests/regressiontests/templates/tests.py
@@ -1,5 +1,5 @@
 # -*- coding: utf-8 -*-
-from __future__ import with_statement, absolute_import
+from __future__ import absolute_import
 
 from django.conf import settings
 
diff --git a/tests/regressiontests/test_utils/tests.py b/tests/regressiontests/test_utils/tests.py
index 7f4208c..3afce90 100644
--- a/tests/regressiontests/test_utils/tests.py
+++ b/tests/regressiontests/test_utils/tests.py
@@ -1,5 +1,5 @@
 # -*- coding: utf-8 -*-
-from __future__ import with_statement, absolute_import
+from __future__ import absolute_import
 
 from django.forms import EmailField, IntegerField
 from django.http import HttpResponse
diff --git a/tests/regressiontests/text/tests.py b/tests/regressiontests/text/tests.py
index 2bbd8ef..e4c4c00 100644
--- a/tests/regressiontests/text/tests.py
+++ b/tests/regressiontests/text/tests.py
@@ -1,5 +1,4 @@
 # coding: utf-8
-from __future__ import with_statement
 
 from django.test import TestCase
 from django.utils.encoding import iri_to_uri
diff --git a/tests/regressiontests/views/tests/debug.py b/tests/regressiontests/views/tests/debug.py
index c6f248a..2be33c4 100644
--- a/tests/regressiontests/views/tests/debug.py
+++ b/tests/regressiontests/views/tests/debug.py
@@ -1,4 +1,4 @@
-from __future__ import with_statement, absolute_import
+from __future__ import absolute_import
 
 import inspect
 import os
diff --git a/tests/regressiontests/views/tests/i18n.py b/tests/regressiontests/views/tests/i18n.py
index 877cf96..9993ae9 100644
--- a/tests/regressiontests/views/tests/i18n.py
+++ b/tests/regressiontests/views/tests/i18n.py
@@ -1,5 +1,5 @@
 # -*- coding:utf-8 -*-
-from __future__ import with_statement, absolute_import
+from __future__ import absolute_import
 
 import gettext
 from os import path
diff --git a/tests/regressiontests/wsgi/tests.py b/tests/regressiontests/wsgi/tests.py
index 9da2adc..9bca2db 100644
--- a/tests/regressiontests/wsgi/tests.py
+++ b/tests/regressiontests/wsgi/tests.py
@@ -1,4 +1,3 @@
-from __future__ import with_statement
 
 from django.core.exceptions import ImproperlyConfigured
 from django.core.servers.basehttp import get_internal_wsgi_application